﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Demo
{
    public partial class DataToolsWindow : Form
    {

        public event EventHandler LookUpHandler;

        public event EventHandler ReplaceHandler;

        public event EventHandler ReplaceAllHandler;

        public event EventHandler WindownClosedHandler;

        public bool AllLookup
        {
            get
            {
                if (cbRange.SelectedIndex == 1)
                    return true;
                else
                    return false;
            }
            set
            {

                if (value)
                {
                    cbRange.SelectedIndex = 1;
                }
                else
                {
                    cbRange.SelectedIndex = 0;
                }
            }
        }

        public bool CanSetRang
        {
            set
            {
                btnLookup.Enabled = false;
                btnReplace.Enabled = false;
                btnAllReplace.Enabled = false;
            }
        }

        public string LookupContent
        {
            get { return txtLookup.Text; }
            set { txtLookup.Text = value; }
        }

        public string ReplaceContent
        {
            get { return txtReplace.Text; }
        }

        public DataToolsWindow()
        {
            InitializeComponent();
            cbRange.SelectedIndex = 0;
        }

        private void btnLookup_Click(object sender, EventArgs e)
        {
            LookUpHandler?.Invoke(sender, e);
        }

        private void btnReplace_Click(object sender, EventArgs e)
        {
            ReplaceHandler?.Invoke(sender, e);
        }

        private void btnAllReplace_Click(object sender, EventArgs e)
        {
            ReplaceAllHandler?.Invoke(sender, e);
        }

        private void ExaminDataToolsWindow_FormClosed(object sender, FormClosedEventArgs e)
        {
            WindownClosedHandler?.Invoke(sender, e);
        }

        private void txtLookup_TextChanged(object sender, EventArgs e)
        {
            btnLookup.Enabled = !string.IsNullOrWhiteSpace(LookupContent);
            btnReplace.Enabled = !string.IsNullOrWhiteSpace(LookupContent);
            btnAllReplace.Enabled = !string.IsNullOrWhiteSpace(LookupContent);
        }

    }
}
