﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;

namespace Demo
{
    public partial class GridDataWindow : Form
    {
        private DataToolsWindow toolsWindow;
        public GridDataWindow()
        {
            InitializeComponent();
        }

        private void ExaminDataWindow_Load(object sender, EventArgs e)
        {
            List<Person> people = new List<Person> {
                new Person{
                    ID=1,
                    Name="张三",
                    Sex="男",
                    Age=18
                },
                 new Person{
                    ID=2,
                    Name="李四",
                    Sex="女",
                    Age=19
                },
                  new Person{
                    ID=3,
                    Name="王五",
                    Sex="男",
                    Age=18
                },
                   new Person{
                    ID=4,
                    Name="赵六",
                    Sex="男",
                    Age=19
                },
                    new Person{
                    ID=5,
                    Name="灵儿",
                    Sex="女",
                    Age=20
                },
            };
            dgvPeople.DataSource = people;
        }
        private void GridDataWindow_FormClosing(object sender, FormClosingEventArgs e)
        {
            dgvPeople.EndEdit();
        }


        private void dgvPepole_CurrentCellChanged(object sender, EventArgs e)
        {
            if (dgvPeople.CurrentCell == null)
            {
                toolStripCol.Text = "";
                return;
            }
            var headerText = dgvPeople.CurrentCell.OwningColumn.HeaderText;
            toolStripCol.Text = "当前列：" + headerText;
        }

 

        private void menuItemLookUpReplace_Click(object sender, EventArgs e)
        {
            if (toolsWindow != null)
                toolsWindow.Activate();
            toolsWindow = new DataToolsWindow();
            toolsWindow.WindownClosedHandler += ToolsWindow_WindownClosedHandler;
            toolsWindow.LookUpHandler += ToolsWindow_LookUpHandler;
            toolsWindow.ReplaceHandler += ToolsWindow_ReplaceHandler;
            toolsWindow.ReplaceAllHandler += ToolsWindow_ReplaceAllHandler;
            if (dgvPeople.CurrentCell == null)
            {
                toolsWindow.AllLookup = true;
                toolsWindow.CanSetRang = false;
            }
            else
            {
                toolsWindow.AllLookup = false;
                toolsWindow.CanSetRang = true;
                toolsWindow.LookupContent = dgvPeople.CurrentCell.Value == null ? "" : dgvPeople.CurrentCell.Value.ToString();
            }
            toolsWindow.Show();
        }

       

 
        private void ToolsWindow_WindownClosedHandler(object sender, EventArgs e)
        {
            if (toolsWindow != null)
                toolsWindow = null;
        }

        private void ToolsWindow_LookUpHandler(object sender, EventArgs e)
        {
            int currentRowIndex = dgvPeople.CurrentCell.RowIndex;
            int currentColumnIndex = dgvPeople.CurrentCell.ColumnIndex;
            foreach (DataGridViewRow row in dgvPeople.Rows)
            {
                //向下查找
                if (row.Index >= currentRowIndex)
                {
                    if (toolsWindow.AllLookup)
                    {
                        //如果是当前选中行 则查找后面的列
                        if (currentRowIndex == row.Index)
                        {
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.ColumnIndex > currentColumnIndex)
                                {
                                    if (cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                    {
                                        cell.Selected = true;
                                        dgvPeople.CurrentCell = cell;
                                        return;
                                    }
                                }
                            }
                        }
                        else
                        { //否则从第一列开始查找
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                {
                                    cell.Selected = true;
                                    dgvPeople.CurrentCell = cell;
                                    return;
                                }
                            }
                        }
                    }
                    else
                    {
                        //字段查找不查找当前 因为是查找下一个
                        if (row.Index == currentRowIndex)
                            continue;
                        if (row.Cells[currentColumnIndex].Value != null && row.Cells[currentColumnIndex].Value.ToString().Contains(toolsWindow.LookupContent))
                        {
                            row.Cells[currentColumnIndex].Selected = true;
                            dgvPeople.CurrentCell = row.Cells[currentColumnIndex];
                            return;
                        }
                    }
                }
            }

            foreach (DataGridViewRow row in dgvPeople.Rows)
            {
                //向上查找
                if (row.Index <= currentRowIndex)
                {
                    if (toolsWindow.AllLookup)
                    {
                        //如果是当前选中行 则查找前面的列
                        if (currentRowIndex == row.Index)
                        {
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.ColumnIndex < currentColumnIndex)
                                {
                                    if (cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                    {
                                        cell.Selected = true;
                                        dgvPeople.CurrentCell = cell;
                                        return;
                                    }
                                }
                            }
                        }
                        else
                        { //否则从第一列开始查找
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                {
                                    cell.Selected = true;
                                    dgvPeople.CurrentCell = cell;
                                    return;
                                }
                            }
                        }
                    }
                    else
                    {
                        //字段查找不查找当前 因为是查找下一个
                        if (row.Index == currentRowIndex)
                            continue;
                        if (row.Cells[currentColumnIndex].Value != null && row.Cells[currentColumnIndex].Value.ToString().Contains(toolsWindow.LookupContent))
                        {
                            row.Cells[currentColumnIndex].Selected = true;
                            dgvPeople.CurrentCell = row.Cells[currentColumnIndex];
                            return;
                        }
                    }
                }
            }

            MessageBox.Show("未找到匹配项！");
        }

        private void ToolsWindow_ReplaceHandler(object sender, EventArgs e)
        {

            int currentRowIndex = dgvPeople.CurrentCell.RowIndex;
            int currentColumnIndex = dgvPeople.CurrentCell.ColumnIndex;
            
            //修改当前选中行
            if (dgvPeople.CurrentCell.Value != null && dgvPeople.CurrentCell.Value.ToString().Contains(toolsWindow.LookupContent))
            {
                dgvPeople.CurrentCell.Value = dgvPeople.CurrentCell.Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                return;
            }
            foreach (DataGridViewRow row in dgvPeople.Rows)
            {
                //向下查找
                if (row.Index >= currentRowIndex)
                {
                    if (toolsWindow.AllLookup)
                    {
                        //如果是当前选中行 则查找后面的列
                        if (currentRowIndex == row.Index)
                        {
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.ColumnIndex > currentColumnIndex)
                                {
                                    if (cell.ColumnIndex != 0 && cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                    {
                                        cell.Selected = true;
                                        dgvPeople.CurrentCell = cell;
                                        cell.Value = cell.Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                                        return;
                                    }
                                }
                            }
                        }
                        else
                        { //否则从第一列开始查找
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.ColumnIndex != 0 && cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                {
                                    cell.Selected = true;
                                    dgvPeople.CurrentCell = cell;
                                    cell.Value = cell.Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                                    return;
                                }
                            }
                        }
                    }
                    else
                    {
                        //字段查找不查找当前 因为是查找下一个
                        if (row.Index == currentRowIndex)
                            continue;
                        if (row.Cells[currentColumnIndex].Value != null && row.Cells[currentColumnIndex].Value.ToString().Contains(toolsWindow.LookupContent))
                        {
                            row.Cells[currentColumnIndex].Selected = true;
                            dgvPeople.CurrentCell = row.Cells[currentColumnIndex];
                            row.Cells[currentColumnIndex].Value = row.Cells[currentColumnIndex].Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                            return;
                        }
                    }
                }
            }

            foreach (DataGridViewRow row in dgvPeople.Rows)
            {
                //向上查找
                if (row.Index <= currentRowIndex)
                {
                    if (toolsWindow.AllLookup)
                    {
                        //如果是当前选中行 则查找前面的列
                        if (currentRowIndex == row.Index)
                        {
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.ColumnIndex < currentColumnIndex)
                                {
                                    if (cell.ColumnIndex != 0 && cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                    {
                                        cell.Selected = true;
                                        dgvPeople.CurrentCell = cell;
                                        cell.Value = cell.Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                                        return;
                                    }
                                }
                            }
                        }
                        else
                        { //否则从第一列开始查找
                            foreach (DataGridViewCell cell in row.Cells)
                            {
                                if (cell.ColumnIndex != 0 && cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                                {
                                    cell.Selected = true;
                                    dgvPeople.CurrentCell = cell;
                                    cell.Value = cell.Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                                    return;
                                }
                            }
                        }
                    }
                    else
                    {
                        //字段查找不查找当前 因为是替换下一个
                        if (row.Index == currentRowIndex)
                            continue;
                        if (row.Cells[currentColumnIndex].Value != null && row.Cells[currentColumnIndex].Value.ToString().Contains(toolsWindow.LookupContent))
                        {
                            row.Cells[currentColumnIndex].Selected = true;
                            dgvPeople.CurrentCell = row.Cells[currentColumnIndex];
                            row.Cells[currentColumnIndex].Value = row.Cells[currentColumnIndex].Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                            return;
                        }
                    }
                }
            }

            MessageBox.Show("未找到匹配项！");
        }

        private void ToolsWindow_ReplaceAllHandler(object sender, EventArgs e)
        {
            bool IsReplace = false;
            int currentColumnIndex = dgvPeople.CurrentCell.ColumnIndex;
           
            foreach (DataGridViewRow row in dgvPeople.Rows)
            {
                if (toolsWindow.AllLookup)
                {
                    foreach (DataGridViewCell cell in row.Cells)
                    {
                        if (cell.ColumnIndex != 0 && cell.Value != null && cell.Value.ToString().Contains(toolsWindow.LookupContent))
                        {
                            cell.Selected = true;
                            cell.Value = cell.Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                            IsReplace = true;
                        }
                    }
                }
                else
                {
                    if (row.Cells[currentColumnIndex].Value != null && row.Cells[currentColumnIndex].Value.ToString().Contains(toolsWindow.LookupContent))
                    {
                        row.Cells[currentColumnIndex].Selected = true;
                        row.Cells[currentColumnIndex].Value = row.Cells[currentColumnIndex].Value.ToString().Replace(toolsWindow.LookupContent, toolsWindow.ReplaceContent);
                        IsReplace = true;
                    }
                }
            }
            if (!IsReplace)
                MessageBox.Show("未找到匹配项！");
        }
       
    }
}
